/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigInteger;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TGENEINSTALLMENTTYPEDESC")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Tgeneinstallmenttypedesc.findAll", query = "SELECT t FROM Tgeneinstallmenttypedesc t"),
    @NamedQuery(name = "Tgeneinstallmenttypedesc.findByInstallmenttype", query = "SELECT t FROM Tgeneinstallmenttypedesc t WHERE t.tgeneinstallmenttypedescPK.installmenttype = :installmenttype"),
    @NamedQuery(name = "Tgeneinstallmenttypedesc.findByModulecode", query = "SELECT t FROM Tgeneinstallmenttypedesc t WHERE t.tgeneinstallmenttypedescPK.modulecode = :modulecode"),
    @NamedQuery(name = "Tgeneinstallmenttypedesc.findByLanguagecode", query = "SELECT t FROM Tgeneinstallmenttypedesc t WHERE t.tgeneinstallmenttypedescPK.languagecode = :languagecode"),
    @NamedQuery(name = "Tgeneinstallmenttypedesc.findByRecordversion", query = "SELECT t FROM Tgeneinstallmenttypedesc t WHERE t.recordversion = :recordversion"),
    @NamedQuery(name = "Tgeneinstallmenttypedesc.findByDescription", query = "SELECT t FROM Tgeneinstallmenttypedesc t WHERE t.description = :description")})
public class Tgeneinstallmenttypedesc implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected TgeneinstallmenttypedescPK tgeneinstallmenttypedescPK;
    @Column(name = "RECORDVERSION")
    private BigInteger recordversion;
    @Column(name = "DESCRIPTION")
    private String description;
    @JoinColumns({
        @JoinColumn(name = "INSTALLMENTTYPE", referencedColumnName = "INSTALLMENTTYPE", insertable = false, updatable = false),
        @JoinColumn(name = "MODULECODE", referencedColumnName = "MODULECODE", insertable = false, updatable = false)})
    @ManyToOne(optional = false)
    private Tgeneinstallmenttype tgeneinstallmenttype;
    @JoinColumn(name = "LANGUAGECODE", referencedColumnName = "LANGUAGECODE", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Tgenelanguage tgenelanguage;

    public Tgeneinstallmenttypedesc() {
    }

    public Tgeneinstallmenttypedesc(TgeneinstallmenttypedescPK tgeneinstallmenttypedescPK) {
        this.tgeneinstallmenttypedescPK = tgeneinstallmenttypedescPK;
    }

    public Tgeneinstallmenttypedesc(String installmenttype, String modulecode, String languagecode) {
        this.tgeneinstallmenttypedescPK = new TgeneinstallmenttypedescPK(installmenttype, modulecode, languagecode);
    }

    public TgeneinstallmenttypedescPK getTgeneinstallmenttypedescPK() {
        return tgeneinstallmenttypedescPK;
    }

    public void setTgeneinstallmenttypedescPK(TgeneinstallmenttypedescPK tgeneinstallmenttypedescPK) {
        this.tgeneinstallmenttypedescPK = tgeneinstallmenttypedescPK;
    }

    public BigInteger getRecordversion() {
        return recordversion;
    }

    public void setRecordversion(BigInteger recordversion) {
        this.recordversion = recordversion;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Tgeneinstallmenttype getTgeneinstallmenttype() {
        return tgeneinstallmenttype;
    }

    public void setTgeneinstallmenttype(Tgeneinstallmenttype tgeneinstallmenttype) {
        this.tgeneinstallmenttype = tgeneinstallmenttype;
    }

    public Tgenelanguage getTgenelanguage() {
        return tgenelanguage;
    }

    public void setTgenelanguage(Tgenelanguage tgenelanguage) {
        this.tgenelanguage = tgenelanguage;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tgeneinstallmenttypedescPK != null ? tgeneinstallmenttypedescPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tgeneinstallmenttypedesc)) {
            return false;
        }
        Tgeneinstallmenttypedesc other = (Tgeneinstallmenttypedesc) object;
        if ((this.tgeneinstallmenttypedescPK == null && other.tgeneinstallmenttypedescPK != null) || (this.tgeneinstallmenttypedescPK != null && !this.tgeneinstallmenttypedescPK.equals(other.tgeneinstallmenttypedescPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.Tgeneinstallmenttypedesc[ tgeneinstallmenttypedescPK=" + tgeneinstallmenttypedescPK + " ]";
    }
    
}
